<?php
  	class io {
		public $socket,$gprog,$ip,$port,$bns,$bnsport,$bnssock,$error,$time,$sesionnt,$try,$bnsiplist;
		public function __construct(){
			include("php/config.php");
			include("php/airconfig.php");
			$this->gprog=$gprog; 
			$this->ip=$ip;
			$this->port=$port;
			$this->bns=$bns;
			$this->bnsport=$bnsport; 
			$this->confi=$Confi;
			$this->mens=0;
			$this->cerrado=false;
			$this->error="";
			$this->sesionnt="";
		}

		public function leer() {
			if($this->cerrado){
				$this->preconectar();
			}
			$cbuf="";
			$tempbuf="";
			$data=[];
			$try=0;
			socket_set_option($this->socket, SOL_SOCKET, SO_RCVTIMEO, array("sec"=>30, "usec"=>0));
			do {
				$fin=true;
				$buf="";
				$abuf="";
				$pos=-1;
				if (false === ($abuf = socket_read($this->socket, 8192))) {
					$this->cerrar($this->socket);
					return "";
				}

				$buf=$tempbuf.$abuf;  
				if(substr($buf,0,1)=="C" or substr($buf,0,1)=="F"){
					$tempbuf=$buf;
					$tempa=[];
					$ltry=0;
					do{
						$ltry=$ltry+1;
						if($ltry>1000){
							echo "Error de conexión 38";
							die();
						}
						if(substr($tempbuf,0,1)=="C" or substr($tempbuf,0,1)=="F"){
							$lastbuf=$tempbuf;
							$clen=substr($tempbuf,1,5);
							if((strlen($tempbuf)-(int)$clen)<0){
								$fin=false;
								break;
							}
							$pbuf=utf8_encode(substr($tempbuf,16,(int)$clen-16));
							$cbuf .= $pbuf;
							$casos=substr($pbuf,0,4);
							switch ($casos) {
								case 'RDAT':
									$rlen=strlen($pbuf);
									$nret=substr($pbuf,5);
									$dline=explode("\r\r",$nret);
									array_push($data, $dline);
									break;
								case 'REND':
									$cbuf=$data;
									break;
								default:
									break;
							}
							$tempbuf=substr($tempbuf,$clen);
						}
					}while(strlen($tempbuf)>16 and (substr($tempbuf,0,1)=="C" or substr($tempbuf,0,1)=="F"));  
				}
				else{
					return $buf." ";
				}
				if(substr($lastbuf,0,1)=="F"&&$fin){
					if(gettype($cbuf)=="array"){
						return $cbuf;
					}
					else{
						return $cbuf;
					}
				}
			}while(true);
		}

		public function conectar(){
			if(!isset($_SESSION['sesion'])){
				$_SESSION['sesion']="0";
			}

			if(strlen($this->bns)==0){
				if(false ===($this->socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP))){
					die("No se pudo establecer la conexión");
				} 
				if(false===($result = socket_connect($this->socket, $this->ip, $this->port))){
					die("No se pudo conectar");
				}	
			}
			else{
				$this->preconectar();
				if(false ===($this->socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP))){
					die("No se pudo establecer la conexión 2");
				}

				if(false===($result = socket_connect($this->socket, $this->ip, $this->port))){
					die("No se pudo conectar 2");
				}	
			}
			return $this->airsegur();
		}

		public function preconectar(){		
			$fp = fopen("http://www.clienteair.com/ipbns.php", "r");
			if(!$fp){
				$ip = gethostbyname("www.clienteair.com");
				$finalport=17692;	
			}
			else{
				$bnsipport=fread($fp,5000);
				$this->bnsiplist=json_decode($bnsipport,true);
				$this->try=0;
				shuffle($this->bnsiplist);
			}
			$this->BNSConnect();
		}
		
		public function BNSConnect(){
			if($this->try==count($this->bnsiplist)){
				die("No se pudo conectar");
				return; 
			}
			$ip=$this->bnsiplist[$this->try][0][0];
			$port=$this->bnsiplist[$this->try][0][1];
			$this->try=$this->try+1;
			if(false ===($this->bnssock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP))){
				die("No se pudo establecer la conexión");
			} 
			if(false===($result = socket_connect($this->bnssock, $ip, $port))){
				socket_close($this->bnssock);
				$this->BNSConnect();
				
			}
			$tosend="START ".$this->bns;
			$msg="C".$this->zeroFill(strlen($tosend)+16,5)."/".$this->zeroFill(strlen($tosend)+16,9).$tosend;
			$this->enviar($msg,$this->bnssock);
			if (false === ($abuf = socket_read($this->bnssock, 8192))) {
				echo "socket_read() failed: reason: " . socket_strerror(socket_last_error($this->bnssock)) . "\n";
				socket_close($this->bnssock);
				die("Error al recibir");
			}
			$Res=substr($abuf,16);
			if(substr($Res, 0,2)==="IP"){
				$gpos=strpos($Res,"-");
				$finalip=trim(substr($Res,3,$gpos-3));
				$finalport=substr($Res,$gpos+1);				
				$this->ip=$finalip;
				$this->port=$finalport;
				$_SESSION['bns']=$this->bns;
				$_SESSION['ip']=$this->ip;
				$_SESSION['port']=$this->port;
			}
			else if(substr($Res, 0,2)==="NT"){
				$fp = fopen("http://www.clienteair.com/bs.php", "r");
				if(!$fp){
					$finalip="212.170.195.50";
					$finalport=9888;	
				}
				else{
					$bsipport=fread($fp,50);
					$finalip=substr($bsipport, 0,strpos($bsipport, ":"));
					$finalport=(int)substr($bsipport, strpos($bsipport, ":")+1);
				}
				$this->sesionnt=substr($Res,3);
				$this->ip=$finalip;
				$this->port=$finalport;
			}
			else{
				socket_close($this->bnssock);
				$this->BNSConnect();
			}
			socket_close($this->bnssock);
		}

		public function cerrar($sock){
			$this->cerrado=true;
			socket_close($sock);
		}

		public function enviar($msg,$sock){
			if($this->cerrado){
				$this->preconectar();
			}
			$_lcvbytes=socket_write($sock, $msg, strlen($msg));
			if($_lcvbytes===false){
				$errorcode = socket_last_error();
				$errormsg = socket_strerror($errorcode);
				$this->error="No se pudo enviar al socket: [$errorcode] $errormsg";
			}
		}

		public function airsegur(){
			$this->enviar("PHP ".$this->sesionnt,$this->socket);
			$this->leer();
			$pag=$this->zeroFill(strlen($_SERVER['PHP_SELF']),2).$_SERVER['PHP_SELF'];
			$browser=$this->getBrowser();
			$nav=$browser['name']." ".$browser['version'];
			$nav=$this->zeroFill(strlen($nav),2).$nav;
			$conf=$this->zeroFill(strlen($this->confi),2).$this->confi;
			$cline="CONF".$pag.$nav.$conf;
			$cline=$this->zeroFill(strlen($cline),4)."11".$cline;
			$this->enviar($cline,$this->socket);
			if(!substr($this->leer(),0,4)=="DCOK"){
				socket_close($this->socket);
				return false;
			}
			return true;
		}

		public function genchain($pre,$query){
			$lcvLenConsulta=str_pad(strlen($query),3, "0",STR_PAD_LEFT);

			$_lcvtry=0;
			do{
				$lcvCadena=$pre.$lcvLenConsulta.$query.$_SESSION['sesion'];
				if(strlen($lcvCadena)<=8192){
					$lcvlen=str_pad(strlen($lcvCadena),4, "0",STR_PAD_LEFT);
					$lcvCad=$lcvlen."11".$lcvCadena;
					$this->enviar($lcvCad,$this->socket);
				}
				else{
					$lcvTemp=$lcvCadena;
					$lcvStart="1";
					$lcvEnd="0";
					do{
						if(strlen($lcvTemp)>8192){
							$lcvlen=8192;
							$lcvCad=$lcvlen.$lcvStart.$lcvEnd.$lcvTemp;
							$this->enviar($lcvCad,$this->socket);
						}
						else{
							$lcvEnd="1";
							$lcvlen=str_pad(strlen($lcvTemp),4, "0",STR_PAD_LEFT);
							$lcvCad=$lcvlen.$lcvStart.$lcvEnd.$lcvTemp;
							$this->enviar($lcvCad,$this->socket);
						}
						$lcvTemp=substr($lcvTemp, $lcvLen);
						$lcvStart="0";
					}while(strlen($lcvTemp)!=0);
				}
				$ret=$this->leer();
				$_lcvtry=$_lcvtry+1;
				if($_lcvtry==5){
					break;
				}
			}while(empty($ret));
			return $ret;
		}

		function zeroFill($number, $width){
			return str_pad(trim((string)$number),$width,"0",STR_PAD_LEFT);
		}

		function getBrowser() { 
			$u_agent = $_SERVER['HTTP_USER_AGENT']; 
			$bname = 'Unknown';
			$platform = 'Unknown';
			$version= "";
			//First get the platform?
			if (preg_match('/linux/i', $u_agent)) {
				$platform = 'linux';
			}
			elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
				$platform = 'mac';
			}
			elseif (preg_match('/windows|win32/i', $u_agent)) {
				$platform = 'windows';
			}
			// Next get the name of the useragent yes seperately and for good reason
			if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent)) 
			{ 
				$bname = 'Internet Explorer'; 
				$ub = "MSIE"; 
			} 
			elseif(preg_match('/Firefox/i',$u_agent)) 
			{ 
				$bname = 'Mozilla Firefox'; 
				$ub = "Firefox"; 
			} 
			elseif(preg_match('/Opera/i',$u_agent)) 
			{ 
				$bname = 'Opera'; 
				$ub = "Opera"; 
			} 
			elseif(preg_match('/OPR/i',$u_agent)) 
			{ 
				$bname = 'Opera'; 
				$ub = "Opera"; 
			}  
			elseif(preg_match('/Chrome/i',$u_agent)) 
			{ 
				$bname = 'Google Chrome'; 
				$ub = "Chrome"; 
			} 
			elseif(preg_match('/Safari/i',$u_agent)) 
			{ 
				$bname = 'Apple Safari'; 
				$ub = "Safari"; 
			} 
			elseif(preg_match('/Netscape/i',$u_agent)) 
			{ 
				$bname = 'Netscape'; 
				$ub = "Netscape"; 
			} 

			// finally get the correct version number
			$known = array('Version', $ub, 'other');
			$pattern = '#(?<browser>' . join('|', $known) .')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
			if (!preg_match_all($pattern, $u_agent, $matches)) {
				// we have no matching number just continue
			}
			// see how many we have
			$i = count($matches['browser']);
			if ($i != 1) {
				//we will have two since we are not using 'other' argument yet
				//see if version is before or after the name
				if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
					$version= $matches['version'][0];
				}
				else {
					$version= $matches['version'][1];
				}
			}
			else {
				$version= $matches['version'][0];
			}

			// check if we have a number
			if ($version==null || $version=="") {$version="?";}
			return array(
				'userAgent' => $u_agent,
				'name'	=> $bname,
				'version'   => $version,
				'platform'  => $platform,
				'pattern'    => $pattern
			);
		}

		function escribirLog($texto) {
			$logfilename = 'Log.log';
			$fp = fopen($logfilename, 'a');
			if ($fp) {
				fwrite($fp, date('M d Y G:i:s') . ' -- ' . $texto . "\r\n");
				fclose($fp);
			}
		}
	}

	
?>